<?php
/**
 * WP Helpdesk Integration plugin file.
 *
 * Copyright (C) 2010-2020, Smackcoders Inc - info@smackcoders.com
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

require_once(plugin_dir_path(__FILE__).'/../ConfigureIncludedPlugins.php');
class SmackHelpDeskUIHelper
{
	public function getActivePlugin()
	{
		return get_option('SmackHelpDeskIntegrationActivePortal');
	}

	public function getPluginActivationHtml( )
	{
		global $availableHelpDeskPortals;
		global $helpDeskInformations;
		$html = '<select name = "pluginselect" id ="pluginselect" onchange="SmackActiveHelpDesk( this )">';
		$select_option = "";
		foreach($availableHelpDeskPortals as $groupName => $availableConfigurations) {
			$select_option .= "<optgroup label='" . $groupName . "'>";
			foreach ( $availableConfigurations as $pluginslug => $pluginlabel ) {
				if ( $this->getActivePlugin() == $pluginslug ) {
					$select_option .= "<option value='{$pluginslug}' selected=selected > {$pluginlabel} </option>";
				} else {
					$select_option .= "<option value='{$pluginslug}' > {$pluginlabel} </option>";
				}
			}
			$select_option .= "</optgroup>";
		}
		$html .= $select_option;
		$html .= "</select>";
		return $html;
	}

	public function getAvailablePlugins( )
	{	
		$html = '<select name = "pluginselect" id ="pluginselect">';
		$select_option = "";
		$select_option .= "<optgroup label='Available Domains'>";
		$select_option .= "<option value='.com' selected=selected > .com </option>";		
		$select_option .= "<option value='.in' > .in </option>";
		$select_option .= "<option value='.eu' > .eu </option>";
				
		$select_option .= "</optgroup>";
		
		$html .= $select_option;
		$html .= "</select>";
		return $html;
	}
}
